#------------------------------------------------------------------------------
#                   C O L L A P S A B L E    F R A M E
#------------------------------------------------------------------------------
set [file rootname [file tail [info script]]]_History {
   $Header: /cvsroot/snackamp/snackamp/lib/cframe.tcl,v 1.11 2004/06/07 02:30:21 wilkason Exp $
}
#------------------------------------------------------------------------------
# Function   : cframe
# Description: Collapsable frame
# base:        name of outer collapsable frame, user is responsible for packing
# text:        title for the window frame, next to collapse button
# args:        additional user settings passed to inner frame
# returns hull: user can pack into this frame
# Author     : William J Giddings, modified by Tom Wilkason
#              Modified by Tom Wilkason for snackAmp such that the cframe
#              adjusts  the height but not the width of the application.
#------------------------------------------------------------------------------
proc cframe {base text args} {
   global cframe
   #-----------------------------------------------------------
   # Add the widget to the parent.
   #-----------------------------------------------------------
   # create button icons
   image create photo im_Open -data {
      R0lGODlhDAAMAPcAAAAAAAEBAQICAgMDAwQEBAUFBQYGBgcHBwgICAkJCQoK
      CgsLCwwMDA0NDQ4ODg8PDxAQEBERERISEhMTExQUFBUVFRYWFhcXFxgYGBkZ
      GRoaGhsbGxwcHB0dHR4eHh8fHyAgICEhISIiIiMjIyQkJCUlJSYmJicnJygo
      KCkpKSoqKisrKywsLC0tLS4uLi8vLzAwMDExMTIyMjMzMzQ0NDU1NTY2Njc3
      Nzg4ODk5OTo6Ojs7Ozw8PD09PT4+Pj8/P0BAQEFBQUJCQkNDQ0REREVFRUZG
      RkdHR0hISElJSUpKSktLS0xMTE1NTU5OTk9PT1BQUFFRUVJSUlNTU1RUVFVV
      VVZWVldXV1hYWFlZWVpaWltbW1xcXF1dXV5eXl9fX2BgYGFhYWJiYmNjY2Rk
      ZGVlZWZmZmdnZ2hoaGlpaWpqamtra2xsbG1tbW5ubm9vb3BwcHFxcXJycnNz
      c3R0dHV1dXZ2dnd3d3h4eHl5eXp6ent7e3x8fH19fX5+fn9/f4CAgIGBgYKC
      goODg4SEhIWFhYaGhoeHh4iIiImJiYqKiouLi4yMjI2NjY6Ojo+Pj5CQkJGR
      kZKSkpOTk5SUlJWVlZaWlpeXl5iYmJmZmZqampubm5ycnJ2dnZ6enp+fn6Cg
      oKGhoaKioqOjo6SkpKWlpaampqenp6ioqKmpqaqqqqurq6ysrK2tra6urq+v
      r7CwsLGxsbKysrOzs7S0tLW1tba2tre3t7i4uLm5ubq6uru7u7y8vL29vb6+
      vr+/v8DAwMHBwcLCwsPDw8TExMXFxcbGxsfHx8jIyMnJycrKysvLy8zMzM3N
      zc7Ozs/Pz9DQ0NHR0dLS0tPT09TU1NXV1dbW1tfX19jY2NnZ2dra2tvb29zc
      3N3d3d7e3t/f3+Dg4OHh4eLi4uPj4+Tk5OXl5ebm5ufn5+jo6Onp6erq6uvr
      6+zs7O3t7e7u7u/v7/Dw8PHx8fLy8vPz8/T09PX19fb29vf39/j4+Pn5+fr6
      +vv7+/z8/P39/f7+/v///yH5BAEAAP4ALAAAAAAMAAwAQAgkAP0JHEiwoEAA
      AAwiXMgwocGHBxtCnEixoUWHFx0SZEix48OAADs=
   }

   image create photo im_Close -data {
      R0lGODlhDAAMAPcAAAAAAAEBAQICAgMDAwQEBAUFBQYGBgcHBwgICAkJCQoK
      CgsLCwwMDA0NDQ4ODg8PDxAQEBERERISEhMTExQUFBUVFRYWFhcXFxgYGBkZ
      GRoaGhsbGxwcHB0dHR4eHh8fHyAgICEhISIiIiMjIyQkJCUlJSYmJicnJygo
      KCkpKSoqKisrKywsLC0tLS4uLi8vLzAwMDExMTIyMjMzMzQ0NDU1NTY2Njc3
      Nzg4ODk5OTo6Ojs7Ozw8PD09PT4+Pj8/P0BAQEFBQUJCQkNDQ0REREVFRUZG
      RkdHR0hISElJSUpKSktLS0xMTE1NTU5OTk9PT1BQUFFRUVJSUlNTU1RUVFVV
      VVZWVldXV1hYWFlZWVpaWltbW1xcXF1dXV5eXl9fX2BgYGFhYWJiYmNjY2Rk
      ZGVlZWZmZmdnZ2hoaGlpaWpqamtra2xsbG1tbW5ubm9vb3BwcHFxcXJycnNz
      c3R0dHV1dXZ2dnd3d3h4eHl5eXp6ent7e3x8fH19fX5+fn9/f4CAgIGBgYKC
      goODg4SEhIWFhYaGhoeHh4iIiImJiYqKiouLi4yMjI2NjY6Ojo+Pj5CQkJGR
      kZKSkpOTk5SUlJWVlZaWlpeXl5iYmJmZmZqampubm5ycnJ2dnZ6enp+fn6Cg
      oKGhoaKioqOjo6SkpKWlpaampqenp6ioqKmpqaqqqqurq6ysrK2tra6urq+v
      r7CwsLGxsbKysrOzs7S0tLW1tba2tre3t7i4uLm5ubq6uru7u7y8vL29vb6+
      vr+/v8DAwMHBwcLCwsPDw8TExMXFxcbGxsfHx8jIyMnJycrKysvLy8zMzM3N
      zc7Ozs/Pz9DQ0NHR0dLS0tPT09TU1NXV1dbW1tfX19jY2NnZ2dra2tvb29zc
      3N3d3d7e3t/f3+Dg4OHh4eLi4uPj4+Tk5OXl5ebm5ufn5+jo6Onp6erq6uvr
      6+zs7O3t7e7u7u/v7/Dw8PHx8fLy8vPz8/T09PX19fb29vf39/j4+Pn5+fr6
      +vv7+/z8/P39/f7+/v///yH5BAEAAP4ALAAAAAAMAAwAQAgqAP0JBCCwoMGB
      ABIeLJiw4UJ/Dh9CbKjwYEWJFx9SxEiRoMWNCyNqlBgQADs=
   }

   frame $base
   # let the user pack the outside base frame
   frame $base.ohull  -borderwidth 1 ;#-height 180 ;#-relief ridge

   button $base.button  -borderwidth 0 \
      -image im_Open \
      -relief raised \
      -activebackground [[winfo toplevel $base] cget -background]
   #   -command [list cframe.toggle $base.ohull.ihull]

   bind $base.button <Button-1> {cframe.toggle [winfo parent %W].ohull.ihull}
   label $base.label  -anchor w -borderwidth 1 -text $text

   #
   # pack special frame/button
   #
   pack $base.ohull -anchor nw -expand 1 -fill both -side left  -ipadx 2 ;#-ipady 10
   place $base.button  -x 0 -y -3 -width 14 -height 20 -anchor nw -bordermode ignore
   place $base.label  -x 16 -y 3  -height 14 -anchor nw -bordermode ignore

   #
   # Create a label underneath the "title" to prevent overlap
   # then pack a frame in below that which will be the hull i.e. childsite for users
   #
   label $base.ohull.padder -text ""
   pack $base.ohull.padder -side top
   set hull $base.ohull.ihull
   # Create the inner frame using any additional arguments passed in
   eval frame {$hull} $args
   pack $hull -expand true -fill both
   # geometry will be "0x0" initially
   foreach {width height} [split [wmGeom $base] x] {break}
   set cframe($base,openSize) $height
   return $hull
}
#-----------------------------------------------------------
# Toggle the widget, toggle the 'can be opened' icon.
# can also called as cframe.toggle $cframeWidget
#-----------------------------------------------------------
proc cframe.toggle {ihull} {
   set button "[winfo parent [winfo parent $ihull]].button"
   set a [$button cget -image]
   if {$a == "im_Open"} {
      cframe.close $ihull
   } else {
      cframe.open $ihull
   }

}
#-----------------------------------------------------------
# Collapse the widget, display the 'can be opened' icon.
# can also called as cframe.close $cframeWidget
#-----------------------------------------------------------
proc cframe.close {ihull} {
   global cframe
   set base [winfo parent [winfo parent $ihull]]
   foreach {width height} [split [wmGeom $base] x] {break}
   $base.button configure -image im_Close
   pack forget $base.ohull
   # Make outer frame just small enough for button and title
   $base configure -height 16 -width 50

   # Restore the size last saved unless it is first time, in that
   # case make the height the default requested height.
   set cframe($base,openSize) $height
   set myTopLevel [winfo toplevel $base]
   if {[info exists cframe($base,closedSize)] && $cframe($base,closedSize) > 0} {
      set height $cframe($base,closedSize)
   } else {
      update idletasks       ;# needed for reqheight to work
      set height [winfo reqheight [winfo toplevel $base]]
   }
   wm geometry $myTopLevel "${width}x$height"
}

#-----------------------------------------------------------
# Open the widget, display the 'can be closed' icon.
# cal also called as cframe.open $cframeWidget
#-----------------------------------------------------------
proc cframe.open {ihull} {
   global cframe
   set base [winfo parent [winfo parent $ihull]]
   foreach {width height} [split [wmGeom $base] x] {break}
   set cframe($base,closedSize) $height
   $base.button configure -image im_Open
   pack $base.ohull -anchor nw -expand 1 -fill both -side left -ipadx 2 -ipady 10
   # Restore the size last saved unless it is first time, in that
   # case make the height the default requested height.
   set myTopLevel [winfo toplevel $base]
   if {[info exists cframe($base,openSize)] && $cframe($base,openSize) > 0} {
      set height $cframe($base,openSize)
   } else {
      update idletasks       ;# needed for reqheight to work
      set height [winfo reqheight [winfo toplevel $base]]
   }
   wm geometry $myTopLevel "${width}x$height"
}
#-----------------------------------------------------------
# Return the geometry
#-----------------------------------------------------------
proc wmGeom {base} {
   set Geom [wm geometry [winfo toplevel $base]]
   set size [lindex [split $Geom "+"] 0]
   # Override initial 1x1 to requested geometry -> {}
   # It hasn't been packed so we don't know at this point
   if {$size == "1x1"} {
      set size {0x0}
   }
   return $size
}

package provide cframe 1.0
