#------------------------------------------------------------------------------
# snackAmp - saImages package 1.0 for snackAmp
# provides various base64 encode images
#
# Music File Player in Tcl/Tk
#
# Copyright (C) 2001 Tom Wilkason
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
#
# Please send any comments/bug reports to
# tom.wilkason@cox.net  (Tom Wilkason)
#------------------------------------------------------------------------------
set [file rootname [file tail [info script]]]_History {
   $Header: /cvsroot/snackamp/snackamp/lib/saImages.tcl,v 1.19 2004/06/07 01:20:57 wilkason Exp $
}
#------------------------------------------------------------------------------
# Function   : createsaImages
# Description: Create icons used in snackamp
# Author     : Tom Wilkason
# Date       : 2/11/2001
#------------------------------------------------------------------------------
namespace eval saImages {
   proc photo {image data} {
      image create photo saImages::$image
      saImages::$image put $data
      variable saImages::$image
   }
}
proc createSAImages {args} {
   # CD ROM image, open folder (used in tree view)
   saImages::photo mp3_player.open {
      R0lGODlhEAAQAIQAAPwCBDQ2NLy6vMzKzISGhJyanMzOzKSipJyenFxaXGRm
      ZJSelGyKXHx+fIyKjJSSlNze3Fx2XKyurGSWbLSytKS2rMTCxAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAALAAAAAAQABAAAAV0ICCOYxCQ
      qGgGgmCma9sO9FkSxTwYB3LYqoRi1zssGAUgICA8HAqLQ6OQJDEVUAKh4XhU
      S4mGFuIdeJXMB5k6EPTQiYIzEllIJN/ggj6ZUFoIcAt9FBUWEgh5SwkPFRWF
      EkVwChIUUUkvKAEKTyspVpmffiEAIf5oQ3JlYXRlZCBieSBCTVBUb0dJRiBQ
      cm8gdmVyc2lvbiAyLjUNCqkgRGV2ZWxDb3IgMTk5NywxOTk4LiBBbGwgcmln
      aHRzIHJlc2VydmVkLg0KaHR0cDovL3d3dy5kZXZlbGNvci5jb20AOw==
   }

   saImages::photo mp3_player.close {
      R0lGODlhEAAQAIQAAPwCBDQ2NLy6vMzKzISGhJyanMzOzKSipJyenFxaXGRm
      ZJSelGyKXHx+fIyKjJSSlNze3Fx2XKyurGSWbLSytKS2rMTCxAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAALAAAAAAQABAAAAV0ICCOYxCQ
      qGgGgmCma9sO9FkSxTwYB3LYqoRi1zssGAUgICA8HAqLQ6OQJDEVUAKh4XhU
      S4mGFuIdeJXMB5k6EPTQiYIzEllIJN/ggj6ZUFoIcAt9FBUWEgh5SwkPFRWF
      EkVwChIUUUkvKAEKTyspVpmffiEAIf5oQ3JlYXRlZCBieSBCTVBUb0dJRiBQ
      cm8gdmVyc2lvbiAyLjUNCqkgRGV2ZWxDb3IgMTk5NywxOTk4LiBBbGwgcmln
      aHRzIHJlc2VydmVkLg0KaHR0cDovL3d3dy5kZXZlbGNvci5jb20AOw==
   }
   saImages::photo Tree.ROM.open {
      R0lGODlhEAAQAIQAAPwCBFxaXISChERCBMTCxKSipAQCBMTCBPzCxPz+xPze
      rMT+xDQyNMTC/ASCBPyqXPz+BARCBAT+BAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAALAAAAAAQABAAAAWIICCKgWAG
      YyoKA+EWhGGogOAaB6Lr8ygUCYWCkEMoEovBSHZUFI8LGYloODJkhWijMbMd
      iAwBQEbYxmpExFlkgN3QrliXAcvNAuVt4coYKtQ9BlwLCQQFMAlVSmwEUX8I
      B1UJiQAObEE6BA9VEDMOEUsDDzoHkZ4LoCkyqyIOCxI9NCOfETJ+IQAh/mhD
      cmVhdGVkIGJ5IEJNUFRvR0lGIFBybyB2ZXJzaW9uIDIuNQ0KqSBEZXZlbENv
      ciAxOTk3LDE5OTguIEFsbCByaWdodHMgcmVzZXJ2ZWQuDQpodHRwOi8vd3d3
      LmRldmVsY29yLmNvbQA7
   }
   # CD ROM image, closed folder (used in tree view)
   saImages::photo Tree.ROM.close {
      R0lGODlhEAAQAIUAAPwCBFxaXISChNTS1MzKzMTGxMy+vNSytAQCBOzq7OTi
      5Nza3Oy6vPy2tOTStPz6/Ozu7Nze3MTKxOS2tNzmvLT2tDw+BPTy9MzOzLS2
      tPy+tLz+tLz2tLSynLzqvLzavLTOtNTW1KSipPz+/MTCxLy6vDQyNOTm5AAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAALAAAAAAQABAAAAap
      QIBQGBAYA8Ok0DggFAwHBEIJECQUi8GT0XBMh9YHJDKQTLqUigWsuDwSmMxB
      Q9lwvoEBQpEoBBAWHRseHyBTAgMhCxgWIiMWFiASJCSHEgQSGQgjmwglGKCH
      BQUSICYWIyIWAwshIVMBIB8eFSQmCAEFCREIekIIFRsUGgcZEgkPFydrvxUU
      Dg0GBSEREGJfv9AMEySsJxDYQ4DcEhh64UpS6lTs7QB+QQAh/mhDcmVhdGVk
      IGJ5IEJNUFRvR0lGIFBybyB2ZXJzaW9uIDIuNQ0KqSBEZXZlbENvciAxOTk3
      LDE5OTguIEFsbCByaWdodHMgcmVzZXJ2ZWQuDQpodHRwOi8vd3d3LmRldmVs
      Y29yLmNvbQA7
   }
   # Folder closed icon, (used in tree view)
   saImages::photo Tree.Folder.close {
      R0lGODlhEAAQAIYAAPwCBAQCBExKTBwWHMzKzOzq7ERCRExGTCwqLARqnAQ+
      ZHR2dKyqrNTOzHx2fCQiJMTi9NTu9HzC3AxmnAQ+XPTm7Dy67DymzITC3IzG
      5AxypHRydKymrMzOzOzu7BweHByy9AyGtFyy1IzG3NTu/ARupFRSVByazBR6
      rAyGvFyuzJTK3MTm9BR+tAxWhHS61MTi7Pz+/IymvCxulBRelAx2rHS63Pz6
      /PTy9PTu9Nza3ISitBRupFSixNTS1CxqnDQyNMzGzOTi5MTCxMTGxGxubGxq
      bLy2vLSutGRiZLy6vLSytKyurDQuNFxaXKSipDw6PAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAA
      LAAAAAAQABAAAAfDgACCAAECg4eIAAMEBQYHCImDBgkKCwwNBQIBBw4Bhw8Q
      ERITFJYEFQUFnoIPFhcYoRkaFBscHR4Ggh8gIRciEiMQJBkltCa6JyUoKSkX
      KhIrLCQYuQAPLS4TEyUhKb0qLzDVAjEFMjMuNBMoNcw21QY3ODkFOjs82RM1
      PfDzFRU3fOggcM7Fj2pAgggRokOHDx9DhhAZUqQaISBGhjwMEvEIkiIHEgUA
      kgSJkiNLmFSMJChAEydPGBSBwvJQgAc0/QQCACH+aENyZWF0ZWQgYnkgQk1Q
      VG9HSUYgUHJvIHZlcnNpb24gMi41DQqpIERldmVsQ29yIDE5OTcsMTk5OC4g
      QWxsIHJpZ2h0cyByZXNlcnZlZC4NCmh0dHA6Ly93d3cuZGV2ZWxjb3IuY29t
      ADs=
   }
   # Folder open icon, (used in tree view)
   saImages::photo Tree.Folder.open {
      R0lGODlhEAAQAIYAAPwCBAQCBExKTBQWFOzi1Ozq7ERCRCwqLPz+/PT29Ozu
      7OTm5FRSVHRydIR+fISCfMTCvAQ6XARqnJSKfIx6XPz6/MzKxJTa9Mzq9JzO
      5PTy7OzizJSOhIyCdOTi5Dy65FTC7HS2zMzm7OTSvNTCnIRyVNza3Dw+PASq
      5BSGrFyqzMyyjMzOzAR+zBRejBxqnBx+rHRmTPTy9IyqvDRylFxaXNze3DRu
      jAQ2VLSyrDQ2NNTW1NTS1AQ6VJyenGxqbMTGxLy6vGRiZKyurKyqrKSmpDw6
      PDw6NAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAA
      LAAAAAAQABAAAAfCgACCAAECg4eIAAMEBQYCB4mHAQgJCgsLDAEGDQGIkw4P
      BQkJBYwQnRESEREIoRMUE6IVChYGERcYGaoRGhsbHBQdHgu2HyAhGSK6qxsj
      JCUmJwARKCkpKsjKqislLNIRLS4vLykw2MkRMRAGhDIJMzTiLzDXETUQ0gAG
      CgU2HjM35N3AkYMdAB0EbCjcwcPCDBguevjIR0jHDwgWLACBECRIBB8GJekQ
      MiRIjhxEIlBMFOBADR9FIhiJ5OnAEQB+AgEAIf5oQ3JlYXRlZCBieSBCTVBU
      b0dJRiBQcm8gdmVyc2lvbiAyLjUNCqkgRGV2ZWxDb3IgMTk5NywxOTk4LiBB
      bGwgcmlnaHRzIHJlc2VydmVkLg0KaHR0cDovL3d3dy5kZXZlbGNvci5jb20A
      Ow==
   }
   # dual not SA icon (32x32)
   saImages::photo saLogo {
      R0lGODlhIAAgALMAANnZ2f//a7HH/wAA/wAxlgAAgJ+f/0hz/2uP////////
      /////////////////////yH5BAEAAAAALAAAAAAgACAAAAT/EMhJq701hCqE
      gAICOWm1MEgJgBhDCAjkpNUCGKQUY4whhIBATlotCEHAIecQQggI5KS1Cjjk
      pEMIAYGctEoxBoFDTjqEgEBOGQIFYgxCCCRwyDkJBHJKGKQEQIxBAACEQAKH
      nCRAIOeEQUoxBoFATlLKGIOEEAIEcs4QxBgkUCrgGATAICUEck4xBgkhBAqg
      GIMAAEAIEMg5xRgEwCBnAGIMAoGcMgQKxBiEwiClGINAIKeEQUoAxBgEAjll
      EGOQECiFQUoxBoFAzinGIDBICYGcMgQxBgmUCjgGAQAGKQEAQggBxBiQhBAC
      BFKKMciUIUgx4BhDiDEIgEHOAMQYqQQCOaUYxpwxxBiQAAAADFKKMQgEckox
      jDFwSEkgkFMGMQYJgUoBhzFwyEkgkHOKMQgMUgIAABkGDjkJAAAIIQQQcAwC
      AAxSAgBIgUPKQgAAYg4hJCQQSBnCBKSMMUqBQIIxEBpDjEHmnCaISAmBlAMZ
      OOQkEMhJqwUDGTjkJBDISasFZRg4pCQEAjlptbLAISeBQE5a7SyljFEKJBDI
      SautpZRy773XBUUAOw==
   }
   # single note SA icon (16x16)
#   saImages::photo icon {
#       R0lGODdhEAAQAPcAAAAAAAAAVQAAqgAA/wAkAAAkVQAkqgAk/wBJAABJVQBJ
#       qgBJ/wBtAABtVQBtqgBt/wCSAACSVQCSqgCS/wC2AAC2VQC2qgC2/wDbAADb
#       VQDbqgDb/wD/AAD/VQD/qgD//yQAACQAVSQAqiQA/yQkACQkVSQkqiQk/yRJ
#       ACRJVSRJqiRJ/yRtACRtVSRtqiRt/ySSACSSVSSSqiSS/yS2ACS2VSS2qiS2
#       /yTbACTbVSTbqiTb/yT/ACT/VST/qiT//0kAAEkAVUkAqkkA/0kkAEkkVUkk
#       qkkk/0lJAElJVUlJqklJ/0ltAEltVUltqklt/0mSAEmSVUmSqkmS/0m2AEm2
#       VUm2qkm2/0nbAEnbVUnbqknb/0n/AEn/VUn/qkn//20AAG0AVW0Aqm0A/20k
#       AG0kVW0kqm0k/21JAG1JVW1Jqm1J/21tAG1tVW1tqm1t/22SAG2SVW2Sqm2S
#       /222AG22VW22qm22/23bAG3bVW3bqm3b/23/AG3/VW3/qm3//5IAAJIAVZIA
#       qpIA/5IkAJIkVZIkqpIk/5JJAJJJVZJJqpJJ/5JtAJJtVZJtqpJt/5KSAJKS
#       VZKSqpKS/5K2AJK2VZK2qpK2/5LbAJLbVZLbqpLb/5L/AJL/VZL/qpL//7YA
#       ALYAVbYAqrYA/7YkALYkVbYkqrYk/7ZJALZJVbZJqrZJ/7ZtALZtVbZtqrZt
#       /7aSALaSVbaSqraS/7a2ALa2Vba2qra2/7bbALbbVbbbqrbb/7b/ALb/Vbb/
#       qrb//9sAANsAVdsAqtsA/9skANskVdskqtsk/9tJANtJVdtJqttJ/9ttANtt
#       Vdttqttt/9uSANuSVduSqtuS/9u2ANu2Vdu2qtu2/9vbANvbVdvbqtvb/9v/
#       ANv/Vdv/qtv///8AAP8AVf8Aqv8A//8kAP8kVf8kqv8k//9JAP9JVf9Jqv9J
#       //9tAP9tVf9tqv9t//+SAP+SVf+Sqv+S//+2AP+2Vf+2qv+2///bAP/bVf/b
#       qv/b////AP//Vf//qv///yH5BAAAAAAALAAAAAAQABAAQAibACU0EEhwoMGC
#       /PgVJDhgQIN+CR1IjOCAYoSGCRUOrBihQUMBAUA2dECQX79+JAc2XNnAooOW
#       GRN6HCChYkWUNR0MeMJTAEaXHSNQXOmwAcmXNWtaJDogqAQJHflx68eNX0OK
#       SY2eFIh0ZsuqGluSpGh1QDd+EpNKyMi0qcAI/BoYbcgzZACMJgdC1TlA5ICX
#       EwFbPBgB6l4HAQEAOw==
#    }

   saImages::photo Close {
      R0lGODlhEAAQAIIAAASC/PwCBMQCBEQCBIQCBAAAAAAAAAAAACH5BAEAAAAA
      LAAAAAAQABAAAAMuCLrc/hCGFyYLQjQsquLDQ2ScEEJjZkYfyQKlJa2j7AQn
      MM7NfucLze1FLD78CQAh/mhDcmVhdGVkIGJ5IEJNUFRvR0lGIFBybyB2ZXJz
      aW9uIDIuNQ0KqSBEZXZlbENvciAxOTk3LDE5OTguIEFsbCByaWdodHMgcmVz
      ZXJ2ZWQuDQpodHRwOi8vd3d3LmRldmVsY29yLmNvbQA7
   }
   # Apply
   saImages::photo Apply {
      R0lGODlhEAAQAIIAAPwCBMT+xATCBASCBARCBAQCBEQCBAAAACH5BAEAAAAA
      LAAAAAAQABAAAAM2CLrc/itAF8RkdVyVye4FpzUgJwijORCGUhDDOZbLG6Nd
      2xjwibIQ2y80sRGIl4IBuWk6Af4EACH+aENyZWF0ZWQgYnkgQk1QVG9HSUYg
      UHJvIHZlcnNpb24gMi41DQqpIERldmVsQ29yIDE5OTcsMTk5OC4gQWxsIHJp
      Z2h0cyByZXNlcnZlZC4NCmh0dHA6Ly93d3cuZGV2ZWxjb3IuY29tADs=
   }

   saImages::photo Save {
      R0lGODlhEAARAIUAAPwCBGRebFxaZOTm9OTi7ExWZPz+/NTS7MTC5Pz6/MS+
      3Nza7Nza9LS21MzO5NTK5CwqLIR+tFxabLSu1Ozm9JSSxOTa5DQyPISCvBQW
      HAQCBIyKvFRSdOTu9GxmpHRyrHx+tBwaHOTe9Kyq1GxqpKSmzBwWHGRinHx6
      tFxenExKjFxanAwKFGxqjAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAALAAAAAAQABEAAAaR
      QIBwKAwQj0fBQIBEBggFg7EpFEANWGYzcAhgv1OiACEwJL5ZYkCBQHgTC8Zi
      0a02FAIH+fA4zCEREgETDQIUAgcVARQWFBcYGBkaZBQMhxUbHB0QHh8ZQhoU
      FBOWEhggIR+eRBoHIhMUIwIfJKtHGiIUFSUmJyifTRojvCm2VBoZKisZHFRD
      GpHNzkMsLU0GQQAh/mhDcmVhdGVkIGJ5IEJNUFRvR0lGIFBybyB2ZXJzaW9u
      IDIuNQ0KqSBEZXZlbENvciAxOTk3LDE5OTguIEFsbCByaWdodHMgcmVzZXJ2
      ZWQuDQpodHRwOi8vd3d3LmRldmVsY29yLmNvbQA7
   }
   # Save As
   saImages::photo SaveAs {
      R0lGODlhEAARAIUAAPwCBGRebFxaZOTm9OTi7ExWZPz+/NTS7MTC5Pz6/MS+
      3Nza7Nza9LS21MzO5NTK5CwqLIR+tFxabLSu1Ozm9JSSxOTa5DQyPISCvBQW
      HAQCBIyKvFRSdOTu9GxmpHRyrHx+tBwaHOTe9Kyq1GxqpKSmzBwWHGRinHx6
      tASmBFxenASCBExKjFxanDzWJIz+bAwKFGxqjAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAALAAAAAAQABEAAAab
      QIBwKAwQj0fBQIBEBggFg7EpFEANWGYzcAhgv1OiACEwJL5ZYkCBQHgTC8Zi
      0a02FAIH+fA4zCEREgETDQIUAgcVARQWFBcYGBkaZBQMhxUbHB0QHh8ZQhoU
      FBOWEhggIR+eRBoHIhMUIwIfJKtHGiIUFSUmJyifQimsI7wqtgApK7cZLC0Z
      HMEuyreR0MguL9NHMDHBK98rBkEAIf5oQ3JlYXRlZCBieSBCTVBUb0dJRiBQ
      cm8gdmVyc2lvbiAyLjUNCqkgRGV2ZWxDb3IgMTk5NywxOTk4LiBBbGwgcmln
      aHRzIHJlc2VydmVkLg0KaHR0cDovL3d3dy5kZXZlbGNvci5jb20AOw==
   }

   # Auto-Playlists (open folder)
   saImages::photo openFile {
      R0lGODlhEgAQAIUAAPwCBAQCBAweVDROlBQ2pAQ2VKTW5GyWtGSitIzC1HzG
      1IzO3GyyzGzC1DSSrEyivFyqxByGrGS+1ITK3DQ2NPTy9ARCZDRynEx+pFSK
      rFy2zGS61Gy+1HTC1PT29OTm5OTi5CxmlDRunER6pEyuzFSyzOzu7Nze3NTS
      1CRijCxulEyCpER+pNza3MzKzMTCxLy+vDx2nMzOzHx+fLSytCxqlBRahAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAALAAAAAASABAAAAae
      QIBwSAwAAkgjUSgQDJNG5FIwIDiPUmEWUDAcCAMn9DksHAwGxHV5FBYSB8Vi
      YSgUlkoug3FoKOQLdmwFDg8QEQcSfhNzd0QUFRYRFxgZGhscHQqOQhQeFR8g
      FiEiIyQlGgicAJAmHycoKBYpKg4rBSyrFBQgLSguLzCzKgUxuUu7MsAzNDMF
      NRerjxQzMMwUKdJsuzAUNtpsnRTadkEAIf5oQ3JlYXRlZCBieSBCTVBUb0dJ
      RiBQcm8gdmVyc2lvbiAyLjUNCqkgRGV2ZWxDb3IgMTk5NywxOTk4LiBBbGwg
      cmlnaHRzIHJlc2VydmVkLg0KaHR0cDovL3d3dy5kZXZlbGNvci5jb20AOw==
   }
   # view file list
   saImages::photo FileList {
      R0lGODlhEAAQAIYAAIyu5Iyy5Hyq5HSq7Gyi5GSe5Fya5GSe7GSi7ARepPwC
      BJS25LTW/JTG/HS6/Eym/CyS/AyC/AR6/AR2/AR+/Jy+5NTm/NTi/MTe/KzW
      9KzS/KTO/KTS/Pz+/PT+/LTO7Oz6/Oz2/Mzu/BxqpJzC9Pz6/MTa/OT6/OT2
      /BRmnKS+5PT6/OTu/JzC5KTC7MTi/Jy65LTO9LzW9DSO1OTy/NzW1DyW1Ly6
      vPyuVPyWJPyeLPz27Ozq7PyqRPyKBPyODPTy9Nze3Py+dPymRPyqTPz25Dya
      1Oz+/NTu/MS+vPzevPzarNzu/Mzq/MTm/PyOFBRinBRqpMzGxLSurOTm7Pyq
      PIymzPzWpPzGhPzKjPz+9ESW1CR2tDya3Dye5DyWzBR+xAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAoA
      LAAAAAAQABAAAAfcgAABAQIDBAUGBwaICAkKCgsMDQ4PEBESE5gSFI4KFRYX
      GBgZGhulpRydFR2sHh0fHx4gISAiI48krCWuJh8dJycoIimPKh0ryCwtLi8v
      GCYZtwourCAgMDEZsDHcMiYzq7Q0uTWs5qw2ubM0xjesODk6Ox02qygoLLk3
      Nzw9Pj9A6LmYhYLGqhtBgAgZQqRIByMVjoRAgSRXkhIdlCxZwmpGAyYimjg5
      GHCIjycOjUCJkiIKlAAdpEyhUuVfQBuPclo5dwVLFi0dtuR8xMWIjRk2unjx
      YuMLGD+BAAAh/mhDcmVhdGVkIGJ5IEJNUFRvR0lGIFBybyB2ZXJzaW9uIDIu
      NQ0KqSBEZXZlbENvciAxOTk3LDE5OTguIEFsbCByaWdodHMgcmVzZXJ2ZWQu
      DQpodHRwOi8vd3d3LmRldmVsY29yLmNvbQA7
   }

   saImages::photo edit-16 {
      R0lGODlhEAAQAIYAAPwCBFxaVMR+RPzKjNze3AQCBMR6RPzGjPyODPz+/MzO
      zPyKDPyKBPz29OTWzPyGDPyGBOx6BOza1OR2BKROBNSOXKRKBBwOBOzu7PTW
      xPzizOySZPyCDFxaXOy2lNRyRMxmJCQOBPTm1OzStPTKrMR+XIRWLFxGNCQS
      BDQyNIRSNDQuJERGRLyqlNzSvIx6ZKRuVEw6LLSyrLymhKSShBwaFFROTJyW
      jMS+vNzW1OTazNzKrHRqXOzezOTOpPTq3OzWvOTStLyedMS+rLy2pMSynMSu
      lAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAA
      LAAAAAAQABAAAAewgAAAAYSFhoQCA4IBBI2OjgUGBwiLBAmXlpcKkgsMlZcJ
      BA0JDpIPEBGVjwkSBgOnExSfmBIVBxAMExYXswkYGRobHLq8gh2PHhoeHyAW
      IYKzIiMkJSYnKCnQg5YNHtQqKywtK9qMBC4vMDEBMjIz2dCMDTQ1Njc4OToz
      5PEEOzw3ZPToMcLHO23HfogQ0QMIkCA+hPBbhAPHECJFjMyYIUQIvEUpUqwQ
      OXKkSEF+AgEAIf5oQ3JlYXRlZCBieSBCTVBUb0dJRiBQcm8gdmVyc2lvbiAy
      LjUNCqkgRGV2ZWxDb3IgMTk5NywxOTk4LiBBbGwgcmlnaHRzIHJlc2VydmVk
      Lg0KaHR0cDovL3d3dy5kZXZlbGNvci5jb20AOw==
   }
   # Play from APL
   saImages::photo noatun2-16 {
      R0lGODlhEAAQAIYAAJy29LzO9MTO/MTS/LzO/FxurPwCBPz+/Pz6/FxyrOzm
      7NTS1Nze7Pz2/PT2/Ozy/FxupNza3KSqpKyutLy2vNTm/FRqpMTKzISChIyO
      jNTi/MTW/FxaXFRSVFxWXISOpKzC/KzK/JSWpBweJCQiJCwmLBwaHAwODAQC
      BBQSFFRmlKzG/ExinIyOnBwWHExSdHyS1JS2/FxqjISq/Iyu/ERalFRSZIya
      xKS+/Hye9ISGlISGnLTG7Iyq/GyS5DxWlDw+TKyyzMzW/KTC/Iyy/Hya7GSK
      3Nzm/NTe/Nzq/LzS/JSy/ERWlFRupGR2rExenCw+bAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAYA
      LAAAAAAQABAAAAe4gAABAgEDg4cEhQUGBgMHjwiPkgiRCYwCjwoLDA2UDQ4P
      DhCXjxESExQMDggPDxUWpAcXGLQZExoNGhuwBgSPFBzBHB0eHyAhvJgHIiMk
      JSYnKCkqKyyxLSjZ2S4vMDHWBsrY2iUyMzM0NYy+B+MnNjc4NDk56uGPOigl
      OzwBAD0+cvyItQNIECEbhhApYsTHQAMbHh1BkkSDkhVLcgRkwqiJkwQfLYh8
      wuKHSSiMUqpcybJlSz+BAAAh/mhDcmVhdGVkIGJ5IEJNUFRvR0lGIFBybyB2
      ZXJzaW9uIDIuNQ0KqSBEZXZlbENvciAxOTk3LDE5OTguIEFsbCByaWdodHMg
      cmVzZXJ2ZWQuDQpodHRwOi8vd3d3LmRldmVsY29yLmNvbQA7
   }
   # www world
   saImages::photo web {
      R0lGODlhEAAQAIYAAPwCBFxONCROfCRKfKx6LNy+bNTOpGSS1DRupAwyXBRS
      nPTSjPTqvOzqzMzSvHSSlKy6ZDxutAxCpBQ2XBxepLTKvPzqzPzy5OTShLS2
      dLSqRFR2jBRerBQ+jOTixOzetNS2XHx6XDR2tCRexBwyTDyKzOTavPzq1OzK
      dCx23BRKtCQ6VCQmHFSa7IyirOzSnGSGpIR+bFSO1DyK7DR+5CRixBw2VDQu
      HFye7IS27NzGXISuhEyS5DR25BRWxBQ+lBQyXCQqPCxSfGyu7GyerKy2ZFR+
      rERqfCRmxBROtBQ+fBwuTBwmNDSW9JyabLyqRIx+TExSXBQ6bAQCBBQ6ZBxa
      pDR+zBxq3LyaLJySRHxqPGxeNBxGbCRmrHRyRERONDRKNDQ2JCQuLAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAA
      LAAAAAAQABAAAAeygACCg4SFhgABAQIDh4MBBAUGBwgDCYcKCwwNDg8QERIT
      hRQVFhcNGBkaGxwdoYMDHhcXHxggISIjEiSvJSYXJwsoISkpIyorLIIDLS4W
      LzAxMjM0NSo2N8o4OS46OzwzPSk+P0BBgkI8Q0NERUZHCEhJSktMgwk4Qy1N
      Tk9QUVJLphCiUsWKlStYsmjZQiJgIS4KuijQ4iXAFxYCDVFJwGUFmDBhMjYS
      w0KMyEYoBfkJBAAh/mhDcmVhdGVkIGJ5IEJNUFRvR0lGIFBybyB2ZXJzaW9u
      IDIuNQ0KqSBEZXZlbENvciAxOTk3LDE5OTguIEFsbCByaWdodHMgcmVzZXJ2
      ZWQuDQpodHRwOi8vd3d3LmRldmVsY29yLmNvbQA7
   }
   saImages::photo NavBack {
      R0lGODlhEAAQAIUAAPwCBBRKvFyKzIzC/HSq/KzW/HSe3Hyy9ITC/Iy+/GSi
      9Gye5HSi5Fx6xGye9Hyu/IS6/HSu/JS+/ISu/Gym9CxWvHy2/IS+/Hyy/Fya
      7DxyzFya9FRuxFyS7ExuvDRmzEx61CRaxAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAALAAAAAAQABAAAAZh
      QIBwSCwaj8hhQJAkBgbMJiBAKBikgQMioTAsGA1HMfAYQCKSyeRBURArlsEF
      Q8lQ7hTxsKJBWCIUG3h5RRwagB0TFIqERR4fghUcIBwcAUcVIQ4NUkIVARyd
      nh6ipZ1+QQAh/mhDcmVhdGVkIGJ5IEJNUFRvR0lGIFBybyB2ZXJzaW9uIDIu
      NQ0KqSBEZXZlbENvciAxOTk3LDE5OTguIEFsbCByaWdodHMgcmVzZXJ2ZWQu
      DQpodHRwOi8vd3d3LmRldmVsY29yLmNvbQA7
   }
   saImages::photo NavForward {
      R0lGODlhEAAQANUAANnZ2UyK3CxGhGSa3DROlKTK/FyS3CxOrHSq7Gym7FyW
      3FSS3Fye9JzG/Gyq/FSK1ISy9KzS/IzC/IS+/IS6/HSu/HSq/GSi9Fya9ER+
      1CxSpHSm7LTS/FyW9EyK7Dxy1Hyy/FSS9EyK9Dx+7CxixJTC/JS+/IS29Dx+
      5DRatERmrExutExmtER+7GSe9CxmzERqtFyG3CxWrExqpP//////////////
      /////////////////////////////////yH5BAEAAAAALAAAAAAQABAAAAZ3
      QIBwSCwaj8hhQJAsBgaEJDFQMByOiIRBsWA0HI+DERKRTCgVywWT0RQ3nAml
      Yrl0PJ7PgbiJUICgyuUSEo1IBwAAAFhESqYTqCNCkVJAgFB4UK1UrE+nRSIN
      h0PhwvWCDYfDYSC2Gg6HQ4BsBgQIh8Si8YgcBgEAOw==
   }
   saImages::photo sortImage {
      R0lGODlhFAATAKIAANnZ2QAA/wAAAKbK8ACAwP///////////yH5BAEAAAAA
      LAAAAAAUABMAAANZCLrcDih0mQVBNXRwBklXBUE1kHR5BUEVRZcbQZfbH0YU
      usyCoBo6OIOkq4KgGki6vIKgiqLLjaDL7Q8jCl1mQVANHZxB0lVBUA0kXV5B
      UEXR5UbQ5faHDyUAOw==
   }
   saImages::photo shuffleImage {
      R0lGODlhFAATAKIAANnZ2QAA/wAAAKbK8ACAwP///////////yH5BAEAAAAA
      LAAAAAAUABMAAANZCLrcjaHLLAiqoYMzSLoqCKqBpMsrCKooutwIutz+MDYU
      usyCoBo6OIOkq4KgGki6vIKgiqLLjaDL7Q8ZCl1mQVANHZxB0lVBUA0kXV5B
      UEXR5UbQ5faHESUAOw==
   }   ;##
   # Modern tree image
   saImages::photo treeImage {
      R0lGODdhEwATANUAAISq5ISq3Hyq3AR2xLTW/KTO/JTG/Hy6/Gyy/Eyi/DSa
      /CSO/AyG/AR+/ARyvKzS/IS+/GSy/ASC/Hym3Nzm/NTi/NTm/Mzi/Mze/MTe
      /Lza9Pz+/JyanPT6/Oz6/Oz2/OT2/Nzy/Lza/OTy/PT+/PyWJPRmJJyenPSW
      HNTu/NTy/Mzu/KzW9Mzq/MTq/KzW/P//////////////////////////////
      /////////////////////////////////ywAAAAAEwATAAAG/0BAICAABAIC
      QCAgAAQCAkBgECAUDAdEQrFgABvCodABIDwMkEhCsZBIiEPHhFKxVCyVyuWC
      uWQwmYwm4wBsNpxNZ9PpeDwfDwgU+ogGgU2HswF2PJ2P5/P5gEahkMgB2Gw4
      pM7m0wGVSiUTaBQSOSabzemz8XhAHxQKZQqFUiIHoEPidDwdkOcDRAlNI5VK
      NAh0OicgRyj8mEwmU0q1EjkAnQ7H8+mAQKPPaKRSpVQsx6Tz4Xw+I9BINVKl
      VKlUiuAAeDocD+gTAo1QQBTKlEq1CIOJB3T6gEIj1QiFQplSLRfBAfh4OKDQ
      JzRKoVAok6W1ejkmHxCHc+JwOCqTyThkcrWALoIDAAKFQKGQapRKpSyplsv1
      GkwyIoxGoxERNBoCgfAisF6OgcPhGDgGjoFjAHQIhQNhEAA7
   }
   # Tree image + filter + hatched-circle
   saImages::photo filterImage {
      R0lGODdhEwATANUAAISq5ISq3Hyq3AR2xLTW/KTO/JTG/Hy6/Gyy/Eyi/DSa
      /CSO/AyG/AR+/ARyvKzS/IS+/GSy/ACAgPRmJHym3Nzm/NTi/NTm/MTe/Lza
      9Pz+/JyanNzy/Oz2/Lza/PT6/ACzs+z6/OTy/AAAANTu/NTy/KzW9PSWHMzq
      /OT2/MTq/Mzu/KzW/Mze/P//////////////////////////////////////
      /////////////////////////////////ywAAAAAEwATAAAG/0BAICAABAIC
      QCAgAAQCAkBgECAUDAdEQrFgABvCodABIDwMkIgEOBEKJcCGUOigVCwXyWQC
      lAiFk4kEk8E4ABrNZjIZDiWTCafjGQQ0n8kECBIOhZPJhONxADSayYRInEwm
      HI+DoplMJhoiCDgRDj0OwEf4CX1AoKFQJPQMAh/hZrPZDEdCktDjAHyGnSEI
      JBKVhiYH5TMcgkCgEqk0JDgAoQ9wIuxwQCDQ6SScoAgDSiglnHBEIBDodBJO
      VAQHoBPaCCccEAh0Ek5QK5aD0kltNkKhUDhRoVQEoAOQSnFSHA5wIhReSCiV
      ijWgYDytTCbjIWQyBAKBRTCxHAOHww0xcAwcA8cA6BAKB8IgADs=
   }
   # Tree image + filter
   saImages::photo filterOff {
      R0lGODdhEwATANUAAISq5ISq3Hyq3AR2xLTW/KTO/JTG/Hy6/Gyy/Eyi/DSa
      /CSO/AyG/AR+/ARyvKzS/IS+/GSy/ACAgHym3Nzm/NTi/NTm/MTe/Lza9Pz+
      /JyanACzs9zy/Oz2/Lza/PT6/PT+/OT2/OTy/JyenPRmJNTu/Oz6/AAAAPSW
      HNTy/Mzu/KzW9Mzq/MTq/KzW/Mze/P//////////////////////////////
      /////////////////////////////////ywAAAAAEwATAAAG/0BAICAABAIC
      QCAgAAQCAkBgECAUDAdEQrFgABvCodABIDwMkAhQIhxKgA2h0DGhVCxAiXBI
      lFwwFwcgk9FsNkXhZsPpeAaBzEcD3AiHxA2H43EAMhkNqEgMiTgexySTGXUy
      RSGJwyl5HIAPSPMxfYgnFEmUSnkGgc9npNFoNEMSCUgqpVQeB+Dz0Zg6n9Bm
      sxGJUqlSauWYfDqaTkcU2mw2qVKqVCoRHADTR2MKdTibzQaFIpVKLAJwMDGF
      Rp0QR7TZbFAoUonVIjgAHZMmxOlwNpsNCkWysFQux6QT0mhGGs1msyGRSC1W
      i+AAhEIcYIjDSW02m5KlxGq1XIPJxR/zwmAwHgIGQyAQXISVyzFwOBwDx8Ax
      cAyADqFwIAwCADs=
   }
   # Append to bottom of queue
   saImages::photo appendImage {
      R0lGODlhFAATAKIAANnZ2aUqKv8AAAAA/wAAAKbK8ACAwP///yH5BAEAAAAA
      LAAAAAAUABMAAAOAGIqgy60YEji6vISgIaFYiqarBAgQEmi6vISgIYGkywwI
      EBIIutyKIYGgy60YEji6vISgIaFYiqarBAgQEmi6vISgIYGkywwIEBIIutyK
      IYGgy60YEhM4ujyEoCEBGFGFpqsECBCCoYqmuwQIECiqEUi6C4CAoRsIutyK
      EQi6zAkAOw==
   }
   # Replace all in queue
   saImages::photo replaceImage {
      R0lGODlhFAATAKIAANnZ2aUqKv8AAAAA/wAAAKbK8ACAwP///yH5BAEAAAAA
      LAAAAAAUABMAAAOIGIqgy60YEji6vISgIaFYiqarBAgQEmi6vISgIYGkywwI
      EBKAgaDLHSgBEQi6zIGCoYqjuwQIECi6gaarBAgQKLqBpqsECBAShKFIugyA
      EBIQGAi6zIESEAi63IESEzi6PISgIQEYUYWmqwQIEIKhiqa7BAgQKKoRSLoL
      gIChGwi63IoRCLrMCQA7
   }
   # Insert into middle of queue
   saImages::photo queue {
      R0lGODlhFAATAKIAANnZ2aUqKv8AAAAA/wAAAKbK8K3Y5gCAwCH5BAEAAAAA
      LAAAAAAUABMAAAODGIqgy60YEji6vISgIaFYiqZ6d0gAEIKBp8tLCBoSSLrM
      gAAhgaDLrRgSCLrciiExEzi6TIAAIQEIEYWmendIABCCcRcSeLpKgAAhERgh
      Eki6CoAQKLoaCLqMoSsSCLq8gzMhgaOrhKA6GhiFpnp3SAiqc4eBp8uEoIqk
      y42gy+0PH0oAOw==
   }
   saImages::photo dropdownImage {
      R0lGODlhCwAUAJEAANnZ2QMCAv///////yH5BAEAAAAALAAAAAALABQAAAIY
      hI+py+0P4yOxCT5EBCJQCB9Tl9sfRkMKADs=
   }
   # Find Next
   saImages::photo findImage {
      R0lGODlhEAAQAIYAAPwCBHSi1ISu3Hym1HSizGSWxHRujFROdJS65LTW9OT2
      /Pz+/PT+/PT6/KTK5DxmjHRylOz2/Oz+/Lzm/BxGdIyKrHSe1Lza9Nzq/FSK
      tExKXGxmjERCZIyy5Lze/KzW/AQuVDwyRExKbDw+XLTW/KzS/JTC9DQuTMTq
      /MTi/LTS/KzK/KTG/KTC/Jy+/BQuRKzG/Jy6/JSy/Jy2/DRmpAQOHEx+rJSy
      9Iym9GSK9FyKpIyCBDxypHSi3HyW/DxuxFxqfPT+dPzmbHRCBAQeNCRelBxS
      jBxWlBRGhMRyDOSiLNzCnOzCfFxafIRKDMSGNOTGlIxODOzChIROBJSOrMyO
      RLRyFHRulJxeJGQ6BCQWBAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAA
      LAAAAAAQABAAAAe6gACCAQIDBAWCiQYHiQgJCgsMDQ4PiYIQAAgRCwsNnhIT
      FIIVghYXnJ4KGBgTGQAaGxwAHaieqx4eHyAhIiMAAxGpGB4kJSQmIAAnJwAB
      KCnQKiUrLC0uyYkvLRcJJTAtMTIzNDWWADYeKi0tNzg4OTo75gA8Pew4Pj9A
      QUJD80RFjBxBUiOJkiVM/AlqMk+QkydQEloS0TDKEylMplDB1FBQlCpVrFw5
      QJFhwylYsojgwKyjIC0A/AQCACH+aENyZWF0ZWQgYnkgQk1QVG9HSUYgUHJv
      IHZlcnNpb24gMi41DQqpIERldmVsQ29yIDE5OTcsMTk5OC4gQWxsIHJpZ2h0
      cyByZXNlcnZlZC4NCmh0dHA6Ly93d3cuZGV2ZWxjb3IuY29tADs=
   }
   saImages::photo pinit {
      R0lGODlhEAAQAIYAAPwCBNTW3NTa3Ozq7IyOjOTq7MzOzJyenKSqrNzi5OTm
      7LSytFRSVISChPTy9Ly+vERGTMzW1BwaHDQyNKSipOzu9MTS3Ly+xLTCzNzK
      bMy6lGRSJMSSfKSCfEQaHNyuDPzqXPTibPzmTPzeTPzCPPSmJOyKDLROBIQy
      BEQiDOS2FPz+bPyqHNyCBKxaBIQ+BHw+BFwuBPz+VPzuVPzSPPy2FOSSBMRu
      BFwyBGw6BPz6PPzuTPzePPzGFOyaBNR2BJROBHw2DEwuBPzeLFQyBOSuHPzq
      LHxCBFQuBDwuBFwqDMSWJPy+DMx2BLReBIxGBGwiDHxOFIRSDGQaBFwOBAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAA
      LAAAAAAQABAAAAengACCAAECAwSDiYMCBQYHCAkGiosKCwyCDQ4PkwAKCRCJ
      DxESkwMCE4kUD6SKFRaogxcYrIkZGhuJHB0eih8gISIjJCUmJygoKYkqKyvA
      JCwtLi8wMYkfMjMiNDU2Ny84OdWDHzo7PD0+P0BBQuHWOkPcN0AvREI44oJF
      Rj02PydHciBJgkNJoiVGmPho4uRJkBgxoBhMFEUKjCBQoEyhwpGTx0l+AgEA
      If5oQ3JlYXRlZCBieSBCTVBUb0dJRiBQcm8gdmVyc2lvbiAyLjUNCqkgRGV2
      ZWxDb3IgMTk5NywxOTk4LiBBbGwgcmlnaHRzIHJlc2VydmVkLg0KaHR0cDov
      L3d3dy5kZXZlbGNvci5jb20AOw==
   }
   saImages::photo unpinit {
      R0lGODlhEAAQAIYAAPwCBOTi5Ozm7OTm7MzS1Nza3Nze5OTq7Nze3KSurJyi
      pMTGxOzy9Ozq7IyGhGxmbIySlKyytLy6vOTq9ExOTFxeXDw+PLyinKyGhNyu
      DPzyZPTidPziTPzWPPyuHOyOFLxaBJQ6BHwmBGQuFOS2FPz+bPz6fPzuZPzi
      XPzKROSGBHw+BGw6BPz+VPzuTPzmTPy6FOyWBMxyBIxGBGw2BFwyBPz6RPze
      LPzGHOyeBNR6BKxaBHwyDPz6POSOBJxOBEwuBOSuHPzyNPzGFDwuBMSWJPzq
      LPzCDLRiBGwqBGQeBHxOFIRSDFwSBGQOFBQGBAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAA
      LAAAAAAQABAAAAeigACCAAECAwQFBoOLgwcICQoKCwiMgwwNDg+CEBESlQAT
      ERSLCwQVlQoOjAIImp+MjxavixcYp4MZGhscHB0eHyAhIiOLJCUmJygpHiog
      KywrixktLi8dMDEyMzQ10bg2Ljc4OTo7LDU1PNI9NzA+Mj8rNUBA3oJBQkMx
      5TPnREAsFhUxcoQckhArkgBRom7REiYreCRRoqRJEydPZmkE4CcQACH+aENy
      ZWF0ZWQgYnkgQk1QVG9HSUYgUHJvIHZlcnNpb24gMi41DQqpIERldmVsQ29y
      IDE5OTcsMTk5OC4gQWxsIHJpZ2h0cyByZXNlcnZlZC4NCmh0dHA6Ly93d3cu
      ZGV2ZWxjb3IuY29tADs=
   }
   #  Hide window
   saImages::photo arrowhide {
      R0lGODlhEAAQAIYAAISu5Iyy5Iyy7Hyu5Hyq7HSm5Gyi7GSe5GSe7GSi7ESa
      7AQ2XAT+BLTW/JTK/Hy6/FSm/DSW/AyG/AR+/AR2/AR6/AQyVJS25NTq/Mze
      /Lze/LTe/KTS/KTG9ITC9JTG/IzK/JTO/Fy6/AQyXJy+5PTi7PRWXPzKzOzy
      /Pzq7PT+/Pz+/Oz6/PxudPSapKTK9PzCxPQeJPQ2PPRaZPSmrOz2/OxWXPQG
      DJy65PS+xPQWHPQCBOyutOz+/OT6/OxibNz2/ITO/KS+7OT2/PQ2RHzK/OTy
      /Nzy/NT2/NTu/NTy/ITG9OyWnOw+ROwyPOS2xNz+/OxebOxWZNTW5ITK/PTC
      xPwCBOSmtOT+/ORebJTG7OSirNT+/OxqdOzG1OTi9Nza7OyarGSq5JTS/HzG
      /AQ2ZAQ6ZAQeNAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAwA
      LAAAAAAQABAAAAfqgAABAgMEBQYHCAcJBwYKCwwCDQ4PEBESExSaFRQTFgwX
      GBkaGxwdHh8gDh4hIiMMJCUmJygpKisrJSwtLiGfLzAxMjM0Kyw1NjM3LR6Q
      OCs5Ojs8PT4oMjs/QEGfQisuMjI5PUNDM0Q2JUWvJCsoKiw+RjVHQEhJSkvd
      xizk9PX3jnj41I5JEydPoABREsWJlClUCPaoosPKFSxKkDixkgVJkU9aKMqw
      sYWLEgxSoljpMpBBhxIzvKD4wuLIETBIuoSh8krMGFZUqHgYSoUMGSoiIC0Y
      UWaEBQsjnEodYeYMg6tYs2q96icQACH+aENyZWF0ZWQgYnkgQk1QVG9HSUYg
      UHJvIHZlcnNpb24gMi41DQqpIERldmVsQ29yIDE5OTcsMTk5OC4gQWxsIHJp
      Z2h0cyByZXNlcnZlZC4NCmh0dHA6Ly93d3cuZGV2ZWxjb3IuY29tADs=
   }
   #  Show window
   saImages::photo arrowshow {
      R0lGODlhEAAQAIYAAISu5Iyy5Iyy7Hyu5Hyq7HSm5Gyi7GSe5GSe7GSi7ESa
      7AQ2XAT+BLTa/JTK/Hy+/FSq/DSW/AyG/AR+/AR2/AR6/AQyVJS65Mze9MzW
      9LTK9KTO/JzO9JzC/IzK9IS+9Iy27Fy2/PyipOwiLPQ2PPSutPz+/PT6/PT+
      /Pzu9PReZPwqNPxOTJy+5AQyXKTS/PSOlPwCBPwmLPTS1Oz+/Oz6/ORqdIS+
      7AQ2ZOxyfPQmLPQiLOTK1OT+/OT6/KTC7PS6xPRyfOzu9OT2/NyyxOTy/OTq
      /ITC9Nzy/Nz2/NT2/ITG9KS+7NT6/NTy/Nz6/Oy6xORufMzy/NTi9JzO/PQq
      NOxufPwCDPSSnNTu/PQmNAQ2VPyirPSuvPxOXGSq5Iy+7IS67HzC9AQeNAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAwA
      LAAAAAAQABAAAAfsgAABAgMEBQYHCAcJBwYKCwwCDQ4PEBESExQVFROcFgwX
      GBkaGhscHR4fIB8dIZ8cIiMkJSYnJigpKissLS4MLzAxMjO1JzQ1NjErNzgM
      GzA5Ojs8PT4+OTE5KiCQPykmQEFCKEM1RDlFRke+LbU0ND1CQ0g+SUpKS59M
      KO/H80VKmjh54kGfEBpQcghJgkQJkShSpjz4RAVGkCojqDlRYuWKDRUAmnnA
      EmNajyxOpEhJpuXGll9cZJDo0mNIkScYdHn50OxLBzBhbngQM9QDgBs3Qvha
      4AKHCxcWnlqwgKMqjjEMsmrdyjWrn0AAIf5oQ3JlYXRlZCBieSBCTVBUb0dJ
      RiBQcm8gdmVyc2lvbiAyLjUNCqkgRGV2ZWxDb3IgMTk5NywxOTk4LiBBbGwg
      cmlnaHRzIHJlc2VydmVkLg0KaHR0cDovL3d3dy5kZXZlbGNvci5jb20AOw==
   }
   saImages::photo apllist {
      R0lGODlhEAAQAIQAAPwCBAQGBLTStPz6/MzizOTy5Pz+/GyybJzKnKTOpOz2
      7EySTGymbHSqdEx6TFyWXFyOXAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAALAAAAAAQABAAAAU7ICCOZGmO
      QaqeqJqSAnsOcesGI0HLJFEYNZfpgEgoFjwAo8FwiG4v0ePhfEJHkGoSoLXi
      tmBbNEwm+UMAIf5oQ3JlYXRlZCBieSBCTVBUb0dJRiBQcm8gdmVyc2lvbiAy
      LjUNCqkgRGV2ZWxDb3IgMTk5NywxOTk4LiBBbGwgcmlnaHRzIHJlc2VydmVk
      Lg0KaHR0cDovL3d3dy5kZXZlbGNvci5jb20AOw==
   }
   # APL find a file
   saImages::photo findfile {
      R0lGODlhEAAQAIYAAPwCBHSi1ISu3Hym1HSizGSWxJS65LTW9OT2/Pz+/PT+
      /PT6/KTK5DxmjOz2/Pz6/PT2/Oz+/Lzm/BxGdHSe1Lza9Oz6/OTy/NTm/FSK
      tIyy5OTu/Mzm/Lze/MTa/KzW/AQyVGyi1LTW/KzS/JTC9MTq/MTi/LzO9KzG
      /KTG/KTC/Jy+/DRahKzO/KzK/Jy6/JSy/Jy2/DRmpAQOHGyOxEx+rLTS/Iym
      9JSm/GSK9FyKpIyCBHyGlDxupHSi3HyW/DxuxFxmfPT+dPzmbHRCBKTK/Jym
      tCRGZBxWlBRKhCQqLLRyFOSiLNzCnOzChOzu/LzG5HSGnFRypCQWBIRKDMSG
      NOzCfMze/Mza/LzS9Iy2/IROBOTGlNzq/NTi/Iy6/IxODMyORNzm/JxeJGQ6
      BEyK5FyS7FSO7ESO9AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAA
      LAAAAAAQABAAAAfVgACCAQIDBAWCiYoABgcICQoLDA2LggYOCQkPCxAREhOL
      FBWZDxYXFxgSGYsapAsOGxwdHh8giiEWDg4XGxIiIyIktokhJRgmJiMnKCkq
      K8OCLCQdIi0uKi8wMTIzijQ1HTYoKzA3ODk6O4otPD0+KjE3P0BBQkNEiUUP
      RkdI/klKljBp4gQfgBQJnkCJEqShlClUqjixgs8FhA1XsGTJckKLoC1VuDjZ
      UgRCFwxevHi48iURmDBhllgU4wXLFQ8eWibaMoZMGTNlcpQZegbNoikA/AQC
      ACH+aENyZWF0ZWQgYnkgQk1QVG9HSUYgUHJvIHZlcnNpb24gMi41DQqpIERl
      dmVsQ29yIDE5OTcsMTk5OC4gQWxsIHJpZ2h0cyByZXNlcnZlZC4NCmh0dHA6
      Ly93d3cuZGV2ZWxjb3IuY29tADs=
   }
   # APL find a folder
   saImages::photo findfolder {
      R0lGODlhEAAQAIYAAPwCBHSi1ISu3Hym1HSizGSWxJS65LTW9OT2/Pz+/PT+
      /PT6/KTK5DxmjOz2/Oz+/Lzm/BxGdHSe1Lza9Nzq/FSKtIyy5Lze/KzW/AQy
      VLTW/KzS/LTS/JTC9MTq/MTi/KzK/KTG/KTC/Jy+/BQuRKzG/Jy6/JSy/Jy2
      /DRmpAQOHEx+rJSy9Iym9GSK9FyKpIyCBDxypHSi3HyW/DxuxFxqfPT+dPzm
      bHRCBAQmPBxWlBRGhMRyDOSiLNzCnOzCfIRKDMSGNOTGlIxODOzChIROBMyO
      RLRyFJxeJGQ6BCQWBAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAA
      LAAAAAAQABAAAAeZgACCAQIDBAWCiYoABgcICQoLDA2LggYOCQkLmw8QEYsS
      E5mbCBQUEBWLFqObphcXGBmKAw6kFBcaGxwdsokBHh/BHBsgISIjvYIkIhMH
      GyUiJicoKSqLKxccIiIsLS0uLzCVMTLcLTM0NTY3OJU5OvA7Kjw9Pj/tlYtA
      QUL3+YtDghD5UeSfoiFGjBwxqKgIkiQMFSkB4CcQACH+aENyZWF0ZWQgYnkg
      Qk1QVG9HSUYgUHJvIHZlcnNpb24gMi41DQqpIERldmVsQ29yIDE5OTcsMTk5
      OC4gQWxsIHJpZ2h0cyByZXNlcnZlZC4NCmh0dHA6Ly93d3cuZGV2ZWxjb3Iu
      Y29tADs=
   }
   saImages::photo refresh {
      R0lGODlhEAAQAIYAAPwCBDzSdDzGdGTWlETOfEzSfGTKjFzOhFTOhFzSjEzS
      hJz2vCyqXHTWlPT+/NT65MT23Lz21KzyxKTuvIzmrDS+bCSiVHzapITytHzy
      rFzulEzmjETafDTCbDSyZCyuXBR+PHTWnMz65HTupGTunFTmjDzafETOdBSC
      RARCHHzipLz61CSaVByOTAx2PCSmVAQ6HJTyvKz6zDyGXAQKBAQeDAxmLCx2
      TEzGfBSGRAQqFARWLByGPBxuNMTu1HzGlITipFS6fGzWlByWTAxSJFy6hFTW
      hDzKdCSeVByKRBx6PBx2PAxeNAReLARKJARGHAQiDAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAA
      LAAAAAAQABAAAAe1gACCg4MBhIeIAgOHBAUGBwcICQUICgsMhA0ODw8QERIT
      FBQNFRaDFw8YGRkaGxwBHR4eHyCCISIjJCUbJicVHgwMKCmCKiskHSwtKCgu
      Li8oMIMxMiYGMzSCNc42LjeDFDgUOTWCOjs2PCg9gj4/QCZBQgUFpRZDNkSC
      RUABAkYFcPzyYIGHDWIAUjA4UgrJkCQolLhYwgRhQgs5bNhownGHxyZOCD1x
      UQ6RyRRQTKpcOchPIAAh/mhDcmVhdGVkIGJ5IEJNUFRvR0lGIFBybyB2ZXJz
      aW9uIDIuNQ0KqSBEZXZlbENvciAxOTk3LDE5OTguIEFsbCByaWdodHMgcmVz
      ZXJ2ZWQuDQpodHRwOi8vd3d3LmRldmVsY29yLmNvbQA7
   }
   saImages::photo filter {
      R0lGODlhEAAQAIQAAPwCBGxqbGRiZIyOjKSepJyenKyurMTCxJyWnFRSVERG
      RHR2dKymrNTS1FxaXKSipLy6vMzGzDQyNHx2fHRudIyGjExOTISChMTGxAAA
      AAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAALAAAAAAQABAAAAVgICCOZGkG
      AoqaYjoQhXEgiVIKC0IwR98cAtvI8XpADpFDo4GQkBSLCS8ZiRgoTlLCseAd
      GAJBtuSoBBwWhZglokAYBSx7dIms5y1MYDxPAPlsChF7eCIKf4UiEoCJJn4h
      ACH+aENyZWF0ZWQgYnkgQk1QVG9HSUYgUHJvIHZlcnNpb24gMi41DQqpIERl
      dmVsQ29yIDE5OTcsMTk5OC4gQWxsIHJpZ2h0cyByZXNlcnZlZC4NCmh0dHA6
      Ly93d3cuZGV2ZWxjb3IuY29tADs=
   }
#    saImages::photo plus {
#       R0lGODlhEAAQAIQAAPwCBERCBKSepJyenJyWnJyanJSWlJSOlJSSlIyKjIyG
#       jISGhIR+hGRiZHx+fHx2fERGBHx6fAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
#       AAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAALAAAAAAQABAAAAVpICCOZGkG
#       aGqSgTAMRLCOQTEY8SzWBHHIpRTKgED8hDtBoWBoHhKKxYIRaABqBYTh8Iwy
#       HI/qtdA7GBQJKYPxgFgDRKPC64hEwm9heuEQillTdVUNhFYsEQ5sfysBYA94
#       On6LK4WFJH4hACH+aENyZWF0ZWQgYnkgQk1QVG9HSUYgUHJvIHZlcnNpb24g
#       Mi41DQqpIERldmVsQ29yIDE5OTcsMTk5OC4gQWxsIHJpZ2h0cyByZXNlcnZl
#       ZC4NCmh0dHA6Ly93d3cuZGV2ZWxjb3IuY29tADs=
#    }
#    saImages::photo minus {
#       R0lGODlhEAAQAIMAAPwCBERCBKSmpGRiZJSWlJyanIyKjIR+hHx6fAAAAAAA
#       AAAAAAAAAAAAAAAAAAAAACH5BAEAAAAALAAAAAAQABAAAAQ4EMhJq704681n
#       +GAYSoFgnqgZDEBAFEbxxnOxtoeh77xxB4jgIYgYEn+i5IcFGDifUGhnSq1a
#       /BEAIf5oQ3JlYXRlZCBieSBCTVBUb0dJRiBQcm8gdmVyc2lvbiAyLjUNCqkg
#       RGV2ZWxDb3IgMTk5NywxOTk4LiBBbGwgcmlnaHRzIHJlc2VydmVkLg0KaHR0
#       cDovL3d3dy5kZXZlbGNvci5jb20AOw==
#    }

   saImages::photo iconthumbsup {
      R0lGODdhEAAQAPcRAAAAAIAAgAAAgACAgACAAICAAIAAAMDAwMDcwKbK8ICA
      gP8A/wAA/wD//wD/AP//AP8AAP/////78KCgpP/w1P/isf/Ujv/Ga/+4SP+q
      Jf+qANySALl6AJZiAHNKAFAyAP/j1P/Hsf+rjv+Pa/9zSP9XJf9VANxJALk9
      AJYxAHMlAFAZAP/U1P+xsf+Ojv9ra/9ISP8lJf8AANwAALkAAJYAAHMAAFAA
      AP/U4/+xx/+Oq/9rj/9Ic/8lV/8AVdwASbkAPZYAMXMAJVAAGf/U8P+x4v+O
      1P9rxv9IuP8lqv8AqtwAkrkAepYAYnMASlAAMv/U//+x//+O//9r//9I//8l
      //8A/9wA3LkAuZYAlnMAc1AAUPDU/+Kx/9SO/8Zr/7hI/6ol/6oA/5IA3HoA
      uWIAlkoAczIAUOPU/8ex/6uO/49r/3NI/1cl/1UA/0kA3D0AuTEAliUAcxkA
      UNTU/7Gx/46O/2tr/0hI/yUl/wAA/wAA3AAAuQAAlgAAcwAAUNTj/7HH/46r
      /2uP/0hz/yVX/wBV/wBJ3AA9uQAxlgAlcwAZUNTw/7Hi/47U/2vG/0i4/yWq
      /wCq/wCS3AB6uQBilgBKcwAyUNT//7H//47//2v//0j//yX//wD//wDc3AC5
      uQCWlgBzcwBQUNT/8LH/4o7/1Gv/xkj/uCX/qgD/qgDckgC5egCWYgBzSgBQ
      MtT/47H/x47/q2v/j0j/cyX/VwD/VQDcSQC5PQCWMQBzJQBQGdT/1LH/sY7/
      jmv/a0j/SCX/JQD/AADcAAC5AACWAABzAABQAOP/1Mf/sav/jo//a3P/SFf/
      JVX/AEncAD25ADGWACVzABlQAPD/1OL/sdT/jsb/a7j/SKr/Jar/AJLcAHq5
      AGKWAEpzADJQAP//1P//sf//jv//a///SP//Jf//ANzcALm5AJaWAHNzAFBQ
      APLy8ubm5tra2s7OzsLCwra2tqqqqp6enpKSkoaGhnp6em5ubmJiYlZWVkpK
      Sj4+PjIyMiYmJhoaGg4ODiH5BAEAAAEALAAAAAAQABAABwhiAAMIHBgAAACC
      CAkCiBDhYEKECw84fDgw4kSKBSMcUHCRIoCNHSsajMix48iRB1Iq4FiRoUaQ
      KWM6PDlyZUyQGRmqBGBzp0CaPHvizLlz3k2WP08ajYn050uOK0smBGoQYUAA
      Ow==
   }
   saImages::photo iconthumbsdown {
      R0lGODdhEAAQAPcRAAAAAIAAgAAAgACAgACAAICAAIAAAMDAwMDcwKbK8ICA
      gP8A/wAA/wD//wD/AP//AP8AAP/////78KCgpP/w1P/isf/Ujv/Ga/+4SP+q
      Jf+qANySALl6AJZiAHNKAFAyAP/j1P/Hsf+rjv+Pa/9zSP9XJf9VANxJALk9
      AJYxAHMlAFAZAP/U1P+xsf+Ojv9ra/9ISP8lJf8AANwAALkAAJYAAHMAAFAA
      AP/U4/+xx/+Oq/9rj/9Ic/8lV/8AVdwASbkAPZYAMXMAJVAAGf/U8P+x4v+O
      1P9rxv9IuP8lqv8AqtwAkrkAepYAYnMASlAAMv/U//+x//+O//9r//9I//8l
      //8A/9wA3LkAuZYAlnMAc1AAUPDU/+Kx/9SO/8Zr/7hI/6ol/6oA/5IA3HoA
      uWIAlkoAczIAUOPU/8ex/6uO/49r/3NI/1cl/1UA/0kA3D0AuTEAliUAcxkA
      UNTU/7Gx/46O/2tr/0hI/yUl/wAA/wAA3AAAuQAAlgAAcwAAUNTj/7HH/46r
      /2uP/0hz/yVX/wBV/wBJ3AA9uQAxlgAlcwAZUNTw/7Hi/47U/2vG/0i4/yWq
      /wCq/wCS3AB6uQBilgBKcwAyUNT//7H//47//2v//0j//yX//wD//wDc3AC5
      uQCWlgBzcwBQUNT/8LH/4o7/1Gv/xkj/uCX/qgD/qgDckgC5egCWYgBzSgBQ
      MtT/47H/x47/q2v/j0j/cyX/VwD/VQDcSQC5PQCWMQBzJQBQGdT/1LH/sY7/
      jmv/a0j/SCX/JQD/AADcAAC5AACWAABzAABQAOP/1Mf/sav/jo//a3P/SFf/
      JVX/AEncAD25ADGWACVzABlQAPD/1OL/sdT/jsb/a7j/SKr/Jar/AJLcAHq5
      AGKWAEpzADJQAP//1P//sf//jv//a///SP//Jf//ANzcALm5AJaWAHNzAFBQ
      APLy8ubm5tra2s7OzsLCwra2tqqqqp6enpKSkoaGhnp6em5ubmJiYlZWVkpK
      Sj4+PjIyMiYmJhoaGg4ODiH5BAEAAAEALAAAAAAQABAABwhjAAMIBECwIEGB
      CAdGOHBAAYAIEA8mNAhgHsMDERE+XNiw4sWOAykqGHnRYYCNHB2SZGiSIsGV
      LAGchJgSwEeTIQ2WxDmx4EKHMhMKPQly6MSfQY0qPJBU6UymTjUybOpUotCA
      ADs=
   }
   saImages::photo coverart {
      R0lGODlhFQASAPcAANnZ2YGBgYmJiYWFgLW1sq6uq8bGwsTEv1FRwc7Ozra2
      0JqatqGhsUBAwwAAuwUFvM/Px+Dg4KysrNHRz0ZG5k1N7kpK60lJ6kZG0To6
      vEFBwD09v0ZGxYODfYqKmlFRkdTUxM/Pv97ev9fXwNTUxuTk1+Pj19fXyt/f
      yN/fx6+vpZ6ejV5ejAUFyImJ3aio/4aG64WF6nx84aOj29HRyqampqmpqbq6
      uIiIyIaG0ZGRxYODpEBArAcHzwAA9QAAaQAAWQAAVwAAWFBQtVtbkkBAOQAA
      AAQEBCgoJjAwbwAAQAsLPxMTPAAANgQEQIODhq+vrwsL83V1fnZ2ZAICAD09
      LYKCch8fFhERB0BANCMjHTU1KUtLS4qKigsL9Xt7k3x8egEBAQYGBpCQkDw8
      PD09PRAQEH19faqqqlZWVouLi3p6knt7eRgYGK6urj4+PgICAlFRUQwMDIKC
      goyMjDc3N1JSUgUFBXl5eZSUlCQkJExMTENDQx4eHjMzMxcXFxoaGggICAkJ
      /4CAmYGBf19fX4iIiBkZGRwcHC0tLT8/PwkJVjMzOxYWFhUVFREREVBQUKSk
      pKOjo46OjhQUFBcXFQkJFQAAFFNTUo2NjeHh17CwsHR0dHNzc2lpaXt7e3d3
      d2tra3Jycnx8dCoqcAAAbgAAbAYGCWlpZp+fn0hISE5OTk1NTVRUTllZTmho
      aP//////////////////////////////////////////////////////////
      ////////////////////////////////////////////////////////////
      ////////////////////////////////////////////////////////////
      ////////////////////////////////////////////////////////////
      ////////////////////////////////////////////////////////////
      /////////////////////yH5BAEAAAAALAAAAAAVABIAAAj/AAEIHCgwgIAB
      BAkSJAiAQAEDBxAQJDgwwUAFABYwaODgAUEIBCNImACAQgULFzBk0LCBA4AO
      Hj4MBCEQRAgRIkaQKGHiBIoUKlawaDHQxYsXMGLEkDGDRg0bN3Dk0LGDR4+B
      Pn4ACRJEyBAiRYwcQZJEyRImTZw8gQIgipQpVIxUsQLwikCBWLIY0bLFiBEu
      Xbx8ARNGzBgyAweWMXMGjREjadR4WcPGSBs3bwYOhBNHzhwjRtLQ8bKGjZE2
      UOoMHAjHzh08RoykoeNlDZswYvLo2TPwShs+fYyIMWIkDR0va9jAMVJGjRE/
      XLj8AcQnkBEjRoykoSNoECEjRowUZjJU5xCiRIoAGhE4MA2dRYzeNHLk6BGk
      SJImcWlDqZKlS5eMYMqkCcAmTp06dfLU6ROoUKI6jSJVytQpVAIAAEilahUr
      Vqz27NnDihUrVq1cuXqlJgAAAAAEqAFIR+BAggMFBJAUEAA7
   }

#    saImages::photo mini_prev {
#       R0lGODlhEAAQAIAAAPwCBAQCBCH5BAEAAAAALAAAAAAQABAAAAIjhI+pyxud
#       wlNyguqkqRZh3h0gl43hpoElqlHt9UKw7NG27BcAIf5oQ3JlYXRlZCBieSBC
#       TVBUb0dJRiBQcm8gdmVyc2lvbiAyLjUNCqkgRGV2ZWxDb3IgMTk5NywxOTk4
#       LiBBbGwgcmlnaHRzIHJlc2VydmVkLg0KaHR0cDovL3d3dy5kZXZlbGNvci5j
#       b20AOw==
#    }
#    saImages::photo mini_play {
#       R0lGODlhEAAQAIAAAPwCBAQCBCH5BAEAAAAALAAAAAAQABAAAAIdhI+pyxCt
#       woNHTmpvy3rxnnwQh1mUI52o6rCu6hcAIf5oQ3JlYXRlZCBieSBCTVBUb0dJ
#       RiBQcm8gdmVyc2lvbiAyLjUNCqkgRGV2ZWxDb3IgMTk5NywxOTk4LiBBbGwg
#       cmlnaHRzIHJlc2VydmVkLg0KaHR0cDovL3d3dy5kZXZlbGNvci5jb20AOw==
#    }
#    saImages::photo mini_pause {
#       R0lGODlhEAAQAIAAAPwCBAQCBCH5BAEAAAAALAAAAAAQABAAAAIfhI+py+1v
#       goxzyUCxrZd18ClfmIyVyJ1lqkHuC0N+AQAh/mhDcmVhdGVkIGJ5IEJNUFRv
#       R0lGIFBybyB2ZXJzaW9uIDIuNQ0KqSBEZXZlbENvciAxOTk3LDE5OTguIEFs
#       bCByaWdodHMgcmVzZXJ2ZWQuDQpodHRwOi8vd3d3LmRldmVsY29yLmNvbQA7
#    }
#    saImages::photo mini_stop {
#       R0lGODlhEAAQAIAAAPwCBAQCBCH5BAEAAAAALAAAAAAQABAAAAIahI+py+1v
#       gpySUWpvXXqrHmSaeJEYhKYq6hcAIf5oQ3JlYXRlZCBieSBCTVBUb0dJRiBQ
#       cm8gdmVyc2lvbiAyLjUNCqkgRGV2ZWxDb3IgMTk5NywxOTk4LiBBbGwgcmln
#       aHRzIHJlc2VydmVkLg0KaHR0cDovL3d3dy5kZXZlbGNvci5jb20AOw==
#    }
#    saImages::photo mini_next {
#       R0lGODlhEAAQAIAAAPwCBAQCBCH5BAEAAAAALAAAAAAQABAAAAIjhI+py8Eb
#       3ENRggrxjRnrVIWcIoYd91FaenysMU6wTNeLXwAAIf5oQ3JlYXRlZCBieSBC
#       TVBUb0dJRiBQcm8gdmVyc2lvbiAyLjUNCqkgRGV2ZWxDb3IgMTk5NywxOTk4
#       LiBBbGwgcmlnaHRzIHJlc2VydmVkLg0KaHR0cDovL3d3dy5kZXZlbGNvci5j
#       b20AOw==
#    }


}
package provide saImages 1.0
